/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.304 Revision 1.369
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.304 2008/09/20 18:45:26 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.369 2011/12/02 03:27:37 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
13# home rather than having multiple ebuilds implementing the same thing. 13# home rather than having multiple ebuilds implementing the same thing.
14# 14#
15# Due to the nature of this eclass, some functions may have maintainers 15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass! 16# different from the overall eclass!
17 17
18inherit multilib portability 18inherit multilib portability user
19 19
20DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
21
22if has "${EAPI:-0}" 0 1 2; then
21 23
22# @FUNCTION: epause 24# @FUNCTION: epause
23# @USAGE: [seconds] 25# @USAGE: [seconds]
24# @DESCRIPTION: 26# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 28# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 30# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 31epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 33}
32 34
33# @FUNCTION: ebeep 35# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 36# @USAGE: [number of beeps]
35# @DESCRIPTION: 37# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 38# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 39# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 41# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 42ebeep() {
41 local n 43 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 46 echo -ne "\a"
47 sleep 1 49 sleep 1
48 done 50 done
49 fi 51 fi
50} 52}
51 53
54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
76fi
77
52# @FUNCTION: ecvs_clean 78# @FUNCTION: ecvs_clean
53# @USAGE: [list of dirs] 79# @USAGE: [list of dirs]
54# @DESCRIPTION: 80# @DESCRIPTION:
55# Remove CVS directories recursiveley. Useful when a source tarball contains 81# Remove CVS directories recursiveley. Useful when a source tarball contains
56# internal CVS directories. Defaults to $PWD. 82# internal CVS directories. Defaults to $PWD.
68esvn_clean() { 94esvn_clean() {
69 [[ -z $* ]] && set -- . 95 [[ -z $* ]] && set -- .
70 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf 96 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
71} 97}
72 98
73# Default directory where patches are located 99# @FUNCTION: eshopts_push
100# @USAGE: [options to `set` or `shopt`]
101# @DESCRIPTION:
102# Often times code will want to enable a shell option to change code behavior.
103# Since changing shell options can easily break other pieces of code (which
104# assume the default state), eshopts_push is used to (1) push the current shell
105# options onto a stack and (2) pass the specified arguments to set.
106#
107# If the first argument is '-s' or '-u', we assume you want to call `shopt`
108# rather than `set` as there are some options only available via that.
109#
110# A common example is to disable shell globbing so that special meaning/care
111# may be used with variables/arguments to custom functions. That would be:
112# @CODE
113# eshopts_push -o noglob
114# for x in ${foo} ; do
115# if ...some check... ; then
116# eshopts_pop
117# return 0
118# fi
119# done
120# eshopts_pop
121# @CODE
122eshopts_push() {
123 # have to assume __ESHOPTS_SAVE__ isn't screwed with
124 # as a `declare -a` here will reset its value
125 local i=${#__ESHOPTS_SAVE__[@]}
126 if [[ $1 == -[su] ]] ; then
127 __ESHOPTS_SAVE__[$i]=$(shopt -p)
128 [[ $# -eq 0 ]] && return 0
129 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
130 else
131 __ESHOPTS_SAVE__[$i]=$-
132 [[ $# -eq 0 ]] && return 0
133 set "$@" || die "eshopts_push: bad options to set: $*"
134 fi
135}
136
137# @FUNCTION: eshopts_pop
138# @USAGE:
139# @DESCRIPTION:
140# Restore the shell options to the state saved with the corresponding
141# eshopts_push call. See that function for more details.
142eshopts_pop() {
143 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
144 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
145 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
146 local s=${__ESHOPTS_SAVE__[$i]}
147 unset __ESHOPTS_SAVE__[$i]
148 if [[ ${s} == "shopt -"* ]] ; then
149 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
150 else
151 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
152 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
153 fi
154}
155
156# @VARIABLE: EPATCH_SOURCE
157# @DESCRIPTION:
158# Default directory to search for patches.
74EPATCH_SOURCE="${WORKDIR}/patch" 159EPATCH_SOURCE="${WORKDIR}/patch"
75# Default extension for patches 160# @VARIABLE: EPATCH_SUFFIX
161# @DESCRIPTION:
162# Default extension for patches (do not prefix the period yourself).
76EPATCH_SUFFIX="patch.bz2" 163EPATCH_SUFFIX="patch.bz2"
164# @VARIABLE: EPATCH_OPTS
165# @DESCRIPTION:
77# Default options for patch 166# Default options for patch:
167# @CODE
78# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 168# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
79# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 169# --no-backup-if-mismatch - do not leave .orig files behind
80# Set -E to automatically remove empty files. 170# -E - automatically remove empty files
171# @CODE
81EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 172EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
173# @VARIABLE: EPATCH_EXCLUDE
174# @DESCRIPTION:
82# List of patches not to apply. Not this is only file names, 175# List of patches not to apply. Note this is only file names,
83# and not the full path .. 176# and not the full path. Globs accepted.
84EPATCH_EXCLUDE="" 177EPATCH_EXCLUDE=""
178# @VARIABLE: EPATCH_SINGLE_MSG
179# @DESCRIPTION:
85# Change the printed message for a single patch. 180# Change the printed message for a single patch.
86EPATCH_SINGLE_MSG="" 181EPATCH_SINGLE_MSG=""
182# @VARIABLE: EPATCH_MULTI_MSG
183# @DESCRIPTION:
87# Change the printed message for multiple patches. 184# Change the printed message for multiple patches.
88EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 185EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
89# Force applying bulk patches even if not following the style: 186# @VARIABLE: EPATCH_FORCE
90# 187# @DESCRIPTION:
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 188# Only require patches to match EPATCH_SUFFIX rather than the extended
92# 189# arch naming style.
93EPATCH_FORCE="no" 190EPATCH_FORCE="no"
94 191
95# This function is for bulk patching, or in theory for just one 192# @FUNCTION: epatch
96# or two patches. 193# @USAGE: [patches] [dirs of patches]
194# @DESCRIPTION:
195# epatch is designed to greatly simplify the application of patches. It can
196# process patch files directly, or directories of patches. The patches may be
197# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
198# the -p option as epatch will automatically attempt -p0 to -p5 until things
199# apply successfully.
97# 200#
98# It should work with .bz2, .gz, .zip and plain text patches. 201# If you do not specify any options, then epatch will default to the directory
99# Currently all patches should be the same format. 202# specified by EPATCH_SOURCE.
100# 203#
101# You do not have to specify '-p' option to patch, as it will 204# When processing directories, epatch will apply all patches that match:
102# try with -p0 to -p5 until it succeed, or fail at -p5. 205# @CODE
103# 206# if ${EPATCH_FORCE} != "yes"
104# Above EPATCH_* variables can be used to control various defaults,
105# bug they should be left as is to ensure an ebuild can rely on
106# them for.
107#
108# Patches are applied in current directory.
109#
110# Bulk Patches should preferibly have the form of:
111#
112# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
208# else
209# *.${EPATCH_SUFFIX}
210# @CODE
211# The leading ?? are typically numbers used to force consistent patch ordering.
212# The arch field is used to apply patches only for the host architecture with
213# the special value of "all" means apply for everyone. Note that using values
214# other than "all" is highly discouraged -- you should apply patches all the
215# time and let architecture details be detected at configure/compile time.
113# 216#
114# For example: 217# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
218# for patches to apply.
115# 219#
116# 01_all_misc-fix.patch.bz2 220# Refer to the other EPATCH_xxx variables for more customization of behavior.
117# 02_sparc_another-fix.patch.bz2
118#
119# This ensures that there are a set order, and you can have ARCH
120# specific patches.
121#
122# If you however give an argument to epatch(), it will treat it as a
123# single patch that need to be applied if its a file. If on the other
124# hand its a directory, it will set EPATCH_SOURCE to this.
125#
126# <azarah@gentoo.org> (10 Nov 2002)
127#
128epatch() { 221epatch() {
129 _epatch_draw_line() { 222 _epatch_draw_line() {
223 # create a line of same length as input string
130 [[ -z $1 ]] && set "$(printf "%65s" '')" 224 [[ -z $1 ]] && set "$(printf "%65s" '')"
131 echo "${1//?/=}" 225 echo "${1//?/=}"
132 } 226 }
133 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
134 local PIPE_CMD=""
135 local STDERR_TARGET="${T}/$$.out"
136 local PATCH_TARGET="${T}/$$.patch"
137 local PATCH_SUFFIX=""
138 local SINGLE_PATCH="no"
139 local x=""
140 227
141 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 228 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
142 229
143 if [ "$#" -gt 1 ] 230 # Let the rest of the code process one user arg at a time --
144 then 231 # each arg may expand into multiple patches, and each arg may
232 # need to start off with the default global EPATCH_xxx values
233 if [[ $# -gt 1 ]] ; then
145 local m="" 234 local m
146 for m in "$@" ; do 235 for m in "$@" ; do
147 epatch "${m}" 236 epatch "${m}"
148 done 237 done
149 return 0 238 return 0
150 fi 239 fi
151 240
152 if [ -n "$1" -a -f "$1" ] 241 local SINGLE_PATCH="no"
153 then 242 # no args means process ${EPATCH_SOURCE}
243 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
244
245 if [[ -f $1 ]] ; then
154 SINGLE_PATCH="yes" 246 SINGLE_PATCH="yes"
155 247 set -- "$1"
156 local EPATCH_SOURCE="$1" 248 # Use the suffix from the single patch (localize it); the code
249 # below will find the suffix for us
157 local EPATCH_SUFFIX="${1##*\.}" 250 local EPATCH_SUFFIX=$1
158 251
159 elif [ -n "$1" -a -d "$1" ] 252 elif [[ -d $1 ]] ; then
160 then 253 # Some people like to make dirs of patches w/out suffixes (vim)
161 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
162 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
260
261 else
262 # sanity check ... if it isn't a dir or file, wtf man ?
263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
264 echo
265 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
266 eerror
267 eerror " ${EPATCH_SOURCE}"
268 eerror " ( ${EPATCH_SOURCE##*/} )"
269 echo
270 die "Cannot find \$EPATCH_SOURCE!"
271 fi
272
273 local PIPE_CMD
274 case ${EPATCH_SUFFIX##*\.} in
275 xz) PIPE_CMD="xz -dc" ;;
276 lzma) PIPE_CMD="lzma -dc" ;;
277 bz2) PIPE_CMD="bzip2 -dc" ;;
278 gz|Z|z) PIPE_CMD="gzip -dc" ;;
279 ZIP|zip) PIPE_CMD="unzip -p" ;;
280 *) ;;
281 esac
282
283 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
284
285 local x
286 for x in "$@" ; do
287 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
288 # didn't match anything, ignore continue on
289 [[ ! -f ${x} ]] && continue
290
291 local patchname=${x##*/}
292
293 # Apply single patches, or forced sets of patches, or
294 # patches with ARCH dependant names.
295 # ???_arch_foo.patch
296 # Else, skip this input altogether
297 local a=${patchname#*_} # strip the ???_
298 a=${a%%_*} # strip the _foo.patch
299 if ! [[ ${SINGLE_PATCH} == "yes" || \
300 ${EPATCH_FORCE} == "yes" || \
301 ${a} == all || \
302 ${a} == ${ARCH} ]]
163 then 303 then
164 local EPATCH_SOURCE="$1/*" 304 continue
305 fi
306
307 # Let people filter things dynamically
308 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
309 # let people use globs in the exclude
310 eshopts_push -o noglob
311
312 local ex
313 for ex in ${EPATCH_EXCLUDE} ; do
314 if [[ ${patchname} == ${ex} ]] ; then
315 eshopts_pop
316 continue 2
317 fi
318 done
319
320 eshopts_pop
321 fi
322
323 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
324 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
325 einfo "${EPATCH_SINGLE_MSG}"
326 else
327 einfo "Applying ${patchname} ..."
328 fi
165 else 329 else
166 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 330 einfo " ${patchname} ..."
167 fi 331 fi
168 else 332
169 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 333 # most of the time, there will only be one run per unique name,
170 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 334 # but if there are more, make sure we get unique log filenames
171 then 335 local STDERR_TARGET="${T}/${patchname}.out"
172 EPATCH_SOURCE="$1" 336 if [[ -e ${STDERR_TARGET} ]] ; then
337 STDERR_TARGET="${T}/${patchname}-$$.out"
338 fi
339
340 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
341
342 # Decompress the patch if need be
343 local count=0
344 local PATCH_TARGET
345 if [[ -n ${PIPE_CMD} ]] ; then
346 PATCH_TARGET="${T}/$$.patch"
347 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
348
349 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
173 fi 355 fi
356 else
357 PATCH_TARGET=${x}
358 fi
174 359
360 # Check for absolute paths in patches. If sandbox is disabled,
361 # people could (accidently) patch files in the root filesystem.
362 # Or trigger other unpleasantries #237667. So disallow -p0 on
363 # such patches.
364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
365 if [[ -n ${abs_paths} ]] ; then
366 count=1
367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
376
377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
378 while [[ ${count} -lt 5 ]] ; do
379 # Generate some useful debug info ...
380 (
381 _epatch_draw_line "***** ${patchname} *****"
175 echo 382 echo
176 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
384 echo
385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
391 ) >> "${STDERR_TARGET}"
392
393 if [ $? -eq 0 ] ; then
394 (
395 _epatch_draw_line "***** ${patchname} *****"
396 echo
397 echo "ACTUALLY APPLYING ${patchname} ..."
398 echo
399 _epatch_draw_line "***** ${patchname} *****"
400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
405 ) >> "${STDERR_TARGET}"
406
407 if [ $? -ne 0 ] ; then
408 echo
409 eerror "A dry-run of patch command succeeded, but actually"
410 eerror "applying the patch failed!"
411 #die "Real world sux compared to the dreamworld!"
412 count=5
413 fi
414 break
415 fi
416
417 : $(( count++ ))
418 done
419
420 # if we had to decompress the patch, delete the temp one
421 if [[ -n ${PIPE_CMD} ]] ; then
422 rm -f "${PATCH_TARGET}"
423 fi
424
425 if [[ ${count} -ge 5 ]] ; then
426 echo
427 eerror "Failed Patch: ${patchname} !"
428 eerror " ( ${PATCH_TARGET} )"
177 eerror 429 eerror
178 eerror " ${EPATCH_SOURCE}" 430 eerror "Include in your bugreport the contents of:"
179 eerror " ( ${EPATCH_SOURCE##*/} )" 431 eerror
432 eerror " ${STDERR_TARGET}"
180 echo 433 echo
181 die "Cannot find \$EPATCH_SOURCE!"
182 fi
183
184 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
185 fi
186
187 case ${EPATCH_SUFFIX##*\.} in
188 lzma)
189 PIPE_CMD="lzma -dc"
190 PATCH_SUFFIX="lzma"
191 ;;
192 bz2)
193 PIPE_CMD="bzip2 -dc"
194 PATCH_SUFFIX="bz2"
195 ;;
196 gz|Z|z)
197 PIPE_CMD="gzip -dc"
198 PATCH_SUFFIX="gz"
199 ;;
200 ZIP|zip)
201 PIPE_CMD="unzip -p"
202 PATCH_SUFFIX="zip"
203 ;;
204 *)
205 PIPE_CMD="cat"
206 PATCH_SUFFIX="patch"
207 ;;
208 esac
209
210 if [ "${SINGLE_PATCH}" = "no" ]
211 then
212 einfo "${EPATCH_MULTI_MSG}"
213 fi
214 for x in ${EPATCH_SOURCE}
215 do
216 # New ARCH dependant patch naming scheme ...
217 #
218 # ???_arch_foo.patch
219 #
220 if [ -f ${x} ] && \
221 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
222 [ "${EPATCH_FORCE}" = "yes" ])
223 then
224 local count=0
225 local popts="${EPATCH_OPTS}"
226 local patchname=${x##*/}
227
228 if [ -n "${EPATCH_EXCLUDE}" ]
229 then
230 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
231 then
232 continue
233 fi
234 fi
235
236 if [ "${SINGLE_PATCH}" = "yes" ]
237 then
238 if [ -n "${EPATCH_SINGLE_MSG}" ]
239 then
240 einfo "${EPATCH_SINGLE_MSG}"
241 else
242 einfo "Applying ${patchname} ..."
243 fi
244 else
245 einfo " ${patchname} ..."
246 fi
247
248 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
249 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
250
251 # Decompress the patch if need be
252 if [[ ${PATCH_SUFFIX} != "patch" ]] ; then
253 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
254 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
255
256 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 ; then
257 echo
258 eerror "Could not extract patch!"
259 #die "Could not extract patch!"
260 count=5
261 break
262 fi
263 else
264 PATCH_TARGET="${x}"
265 fi
266
267 # Allow for prefix to differ ... im lazy, so shoot me :/
268 while [ "${count}" -lt 5 ]
269 do
270 # Generate some useful debug info ...
271 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
272 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273
274 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
275 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276
277 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
278 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279
280 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
281 then
282 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
283 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
284 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
285 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
286 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
287
288 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
289 _epatch_assert
290
291 if [ "$?" -ne 0 ]
292 then
293 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
294 echo
295 eerror "A dry-run of patch command succeeded, but actually"
296 eerror "applying the patch failed!"
297 #die "Real world sux compared to the dreamworld!"
298 count=5
299 fi
300
301 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
302
303 break
304 fi
305
306 count=$((count + 1))
307 done
308
309 if [ "${PATCH_SUFFIX}" != "patch" ]
310 then
311 rm -f ${PATCH_TARGET}
312 fi
313
314 if [ "${count}" -eq 5 ]
315 then
316 echo
317 eerror "Failed Patch: ${patchname} !"
318 eerror " ( ${PATCH_TARGET} )"
319 eerror
320 eerror "Include in your bugreport the contents of:"
321 eerror
322 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
323 echo
324 die "Failed Patch: ${patchname}!" 434 die "Failed Patch: ${patchname}!"
325 fi 435 fi
326 436
327 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 437 # if everything worked, delete the patch log
328 438 rm -f "${STDERR_TARGET}"
329 eend 0 439 eend 0
330 fi
331 done 440 done
332 if [ "${SINGLE_PATCH}" = "no" ] 441
333 then 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
334 einfo "Done with patching" 443 : # everything worked
444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
472epatch_user() {
473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
478
479 # don't clobber any EPATCH vars that the parent might want
480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
483 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
485 if [[ -d ${EPATCH_SOURCE} ]] ; then
486 EPATCH_SOURCE=${EPATCH_SOURCE} \
487 EPATCH_SUFFIX="patch" \
488 EPATCH_FORCE="yes" \
489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
490 epatch
491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
335 fi 493 fi
494 done
495 echo "none" > "${applied}"
496 return 1
336} 497}
337 498
338# @FUNCTION: emktemp 499# @FUNCTION: emktemp
339# @USAGE: [temp dir] 500# @USAGE: [temp dir]
340# @DESCRIPTION: 501# @DESCRIPTION:
368 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX 529 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
369 fi 530 fi
370 fi 531 fi
371} 532}
372 533
373# @FUNCTION: egetent
374# @USAGE: <database> <key>
375# @MAINTAINER:
376# base-system@gentoo.org (Linux)
377# Joe Jezak <josejx@gmail.com> (OS X)
378# usata@gentoo.org (OS X)
379# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
380# @DESCRIPTION:
381# Small wrapper for getent (Linux), nidump (Mac OS X),
382# and pw (FreeBSD) used in enewuser()/enewgroup()
383egetent() {
384 case ${CHOST} in
385 *-darwin*)
386 case "$2" in
387 *[!0-9]*) # Non numeric
388 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
389 ;;
390 *) # Numeric
391 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
392 ;;
393 esac
394 ;;
395 *-freebsd*|*-dragonfly*)
396 local opts action="user"
397 [[ $1 == "passwd" ]] || action="group"
398
399 # lookup by uid/gid
400 if [[ $2 == [[:digit:]]* ]] ; then
401 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
402 fi
403
404 pw show ${action} ${opts} "$2" -q
405 ;;
406 *-netbsd*|*-openbsd*)
407 grep "$2:\*:" /etc/$1
408 ;;
409 *)
410 type -p nscd >& /dev/null && nscd -i "$1"
411 getent "$1" "$2"
412 ;;
413 esac
414}
415
416# @FUNCTION: enewuser
417# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
418# @DESCRIPTION:
419# Same as enewgroup, you are not required to understand how to properly add
420# a user to the system. The only required parameter is the username.
421# Default uid is (pass -1 for this) next available, default shell is
422# /bin/false, default homedir is /dev/null, there are no default groups,
423# and default params sets the comment as 'added by portage for ${PN}'.
424enewuser() {
425 case ${EBUILD_PHASE} in
426 unpack|compile|test|install)
427 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
428 eerror "Package fails at QA and at life. Please file a bug."
429 die "Bad package! enewuser is only for use in pkg_* functions!"
430 esac
431
432 # get the username
433 local euser=$1; shift
434 if [[ -z ${euser} ]] ; then
435 eerror "No username specified !"
436 die "Cannot call enewuser without a username"
437 fi
438
439 # lets see if the username already exists
440 if [[ -n $(egetent passwd "${euser}") ]] ; then
441 return 0
442 fi
443 einfo "Adding user '${euser}' to your system ..."
444
445 # options to pass to useradd
446 local opts=
447
448 # handle uid
449 local euid=$1; shift
450 if [[ -n ${euid} && ${euid} != -1 ]] ; then
451 if [[ ${euid} -gt 0 ]] ; then
452 if [[ -n $(egetent passwd ${euid}) ]] ; then
453 euid="next"
454 fi
455 else
456 eerror "Userid given but is not greater than 0 !"
457 die "${euid} is not a valid UID"
458 fi
459 else
460 euid="next"
461 fi
462 if [[ ${euid} == "next" ]] ; then
463 for ((euid = 101; euid <= 999; euid++)); do
464 [[ -z $(egetent passwd ${euid}) ]] && break
465 done
466 fi
467 opts="${opts} -u ${euid}"
468 einfo " - Userid: ${euid}"
469
470 # handle shell
471 local eshell=$1; shift
472 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
473 if [[ ! -e ${ROOT}${eshell} ]] ; then
474 eerror "A shell was specified but it does not exist !"
475 die "${eshell} does not exist in ${ROOT}"
476 fi
477 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
478 eerror "Do not specify ${eshell} yourself, use -1"
479 die "Pass '-1' as the shell parameter"
480 fi
481 else
482 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
483 [[ -x ${ROOT}${shell} ]] && break
484 done
485
486 if [[ ${shell} == "/dev/null" ]] ; then
487 eerror "Unable to identify the shell to use, proceeding with userland default."
488 case ${USERLAND} in
489 GNU) shell="/bin/false" ;;
490 BSD) shell="/sbin/nologin" ;;
491 Darwin) shell="/usr/sbin/nologin" ;;
492 *) die "Unable to identify the default shell for userland ${USERLAND}"
493 esac
494 fi
495
496 eshell=${shell}
497 fi
498 einfo " - Shell: ${eshell}"
499 opts="${opts} -s ${eshell}"
500
501 # handle homedir
502 local ehome=$1; shift
503 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
504 ehome="/dev/null"
505 fi
506 einfo " - Home: ${ehome}"
507 opts="${opts} -d ${ehome}"
508
509 # handle groups
510 local egroups=$1; shift
511 if [[ ! -z ${egroups} ]] ; then
512 local oldifs=${IFS}
513 local defgroup="" exgroups=""
514
515 export IFS=","
516 for g in ${egroups} ; do
517 export IFS=${oldifs}
518 if [[ -z $(egetent group "${g}") ]] ; then
519 eerror "You must add group ${g} to the system first"
520 die "${g} is not a valid GID"
521 fi
522 if [[ -z ${defgroup} ]] ; then
523 defgroup=${g}
524 else
525 exgroups="${exgroups},${g}"
526 fi
527 export IFS=","
528 done
529 export IFS=${oldifs}
530
531 opts="${opts} -g ${defgroup}"
532 if [[ ! -z ${exgroups} ]] ; then
533 opts="${opts} -G ${exgroups:1}"
534 fi
535 else
536 egroups="(none)"
537 fi
538 einfo " - Groups: ${egroups}"
539
540 # handle extra and add the user
541 local oldsandbox=${SANDBOX_ON}
542 export SANDBOX_ON="0"
543 case ${CHOST} in
544 *-darwin*)
545 ### Make the user
546 if [[ -z $@ ]] ; then
547 dscl . create /users/${euser} uid ${euid}
548 dscl . create /users/${euser} shell ${eshell}
549 dscl . create /users/${euser} home ${ehome}
550 dscl . create /users/${euser} realname "added by portage for ${PN}"
551 ### Add the user to the groups specified
552 local oldifs=${IFS}
553 export IFS=","
554 for g in ${egroups} ; do
555 dscl . merge /groups/${g} users ${euser}
556 done
557 export IFS=${oldifs}
558 else
559 einfo "Extra options are not supported on Darwin yet"
560 einfo "Please report the ebuild along with the info below"
561 einfo "eextra: $@"
562 die "Required function missing"
563 fi
564 ;;
565 *-freebsd*|*-dragonfly*)
566 if [[ -z $@ ]] ; then
567 pw useradd ${euser} ${opts} \
568 -c "added by portage for ${PN}" \
569 die "enewuser failed"
570 else
571 einfo " - Extra: $@"
572 pw useradd ${euser} ${opts} \
573 "$@" || die "enewuser failed"
574 fi
575 ;;
576
577 *-netbsd*)
578 if [[ -z $@ ]] ; then
579 useradd ${opts} ${euser} || die "enewuser failed"
580 else
581 einfo " - Extra: $@"
582 useradd ${opts} ${euser} "$@" || die "enewuser failed"
583 fi
584 ;;
585
586 *-openbsd*)
587 if [[ -z $@ ]] ; then
588 useradd -u ${euid} -s ${eshell} \
589 -d ${ehome} -c "Added by portage for ${PN}" \
590 -g ${egroups} ${euser} || die "enewuser failed"
591 else
592 einfo " - Extra: $@"
593 useradd -u ${euid} -s ${eshell} \
594 -d ${ehome} -c "Added by portage for ${PN}" \
595 -g ${egroups} ${euser} "$@" || die "enewuser failed"
596 fi
597 ;;
598
599 *)
600 if [[ -z $@ ]] ; then
601 useradd ${opts} ${euser} \
602 -c "added by portage for ${PN}" \
603 || die "enewuser failed"
604 else
605 einfo " - Extra: $@"
606 useradd ${opts} ${euser} "$@" \
607 || die "enewuser failed"
608 fi
609 ;;
610 esac
611
612 if [[ ! -e ${ROOT}/${ehome} ]] ; then
613 einfo " - Creating ${ehome} in ${ROOT}"
614 mkdir -p "${ROOT}/${ehome}"
615 chown ${euser} "${ROOT}/${ehome}"
616 chmod 755 "${ROOT}/${ehome}"
617 fi
618
619 export SANDBOX_ON=${oldsandbox}
620}
621
622# @FUNCTION: enewgroup
623# @USAGE: <group> [gid]
624# @DESCRIPTION:
625# This function does not require you to understand how to properly add a
626# group to the system. Just give it a group name to add and enewgroup will
627# do the rest. You may specify the gid for the group or allow the group to
628# allocate the next available one.
629enewgroup() {
630 case ${EBUILD_PHASE} in
631 unpack|compile|test|install)
632 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
633 eerror "Package fails at QA and at life. Please file a bug."
634 die "Bad package! enewgroup is only for use in pkg_* functions!"
635 esac
636
637 # get the group
638 local egroup="$1"; shift
639 if [ -z "${egroup}" ]
640 then
641 eerror "No group specified !"
642 die "Cannot call enewgroup without a group"
643 fi
644
645 # see if group already exists
646 if [[ -n $(egetent group "${egroup}") ]]; then
647 return 0
648 fi
649 einfo "Adding group '${egroup}' to your system ..."
650
651 # options to pass to useradd
652 local opts=
653
654 # handle gid
655 local egid="$1"; shift
656 if [ ! -z "${egid}" ]
657 then
658 if [ "${egid}" -gt 0 ]
659 then
660 if [ -z "`egetent group ${egid}`" ]
661 then
662 if [[ "${CHOST}" == *-darwin* ]]; then
663 opts="${opts} ${egid}"
664 else
665 opts="${opts} -g ${egid}"
666 fi
667 else
668 egid="next available; requested gid taken"
669 fi
670 else
671 eerror "Groupid given but is not greater than 0 !"
672 die "${egid} is not a valid GID"
673 fi
674 else
675 egid="next available"
676 fi
677 einfo " - Groupid: ${egid}"
678
679 # handle extra
680 local eextra="$@"
681 opts="${opts} ${eextra}"
682
683 # add the group
684 local oldsandbox="${SANDBOX_ON}"
685 export SANDBOX_ON="0"
686 case ${CHOST} in
687 *-darwin*)
688 if [ ! -z "${eextra}" ];
689 then
690 einfo "Extra options are not supported on Darwin/OS X yet"
691 einfo "Please report the ebuild along with the info below"
692 einfo "eextra: ${eextra}"
693 die "Required function missing"
694 fi
695
696 # If we need the next available
697 case ${egid} in
698 *[!0-9]*) # Non numeric
699 for ((egid = 101; egid <= 999; egid++)); do
700 [[ -z $(egetent group ${egid}) ]] && break
701 done
702 esac
703 dscl . create /groups/${egroup} gid ${egid}
704 dscl . create /groups/${egroup} passwd '*'
705 ;;
706
707 *-freebsd*|*-dragonfly*)
708 case ${egid} in
709 *[!0-9]*) # Non numeric
710 for ((egid = 101; egid <= 999; egid++)); do
711 [[ -z $(egetent group ${egid}) ]] && break
712 done
713 esac
714 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
715 ;;
716
717 *-netbsd*)
718 case ${egid} in
719 *[!0-9]*) # Non numeric
720 for ((egid = 101; egid <= 999; egid++)); do
721 [[ -z $(egetent group ${egid}) ]] && break
722 done
723 esac
724 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
725 ;;
726
727 *)
728 groupadd ${opts} ${egroup} || die "enewgroup failed"
729 ;;
730 esac
731 export SANDBOX_ON="${oldsandbox}"
732}
733
734# @FUNCTION: edos2unix 534# @FUNCTION: edos2unix
735# @USAGE: <file> [more files ...] 535# @USAGE: <file> [more files ...]
736# @DESCRIPTION: 536# @DESCRIPTION:
737# A handy replacement for dos2unix, recode, fixdos, etc... This allows you 537# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
738# to remove all of these text utilities from DEPEND variables because this 538# to remove all of these text utilities from DEPEND variables because this
739# is a script based solution. Just give it a list of files to convert and 539# is a script based solution. Just give it a list of files to convert and
740# they will all be changed from the DOS CRLF format to the UNIX LF format. 540# they will all be changed from the DOS CRLF format to the UNIX LF format.
741edos2unix() { 541edos2unix() {
742 echo "$@" | xargs sed -i 's/\r$//' 542 [[ $# -eq 0 ]] && return 0
543 sed -i 's/\r$//' -- "$@" || die
743} 544}
744 545
745# Make a desktop file ! 546# Make a desktop file !
746# Great for making those icons in kde/gnome startmenu ! 547# Great for making those icons in kde/gnome startmenu !
747# Amaze your friends ! Get the women ! Join today ! 548# Amaze your friends ! Get the women ! Join today !
748# 549#
749# make_desktop_entry(<command>, [name], [icon], [type], [path]) 550# make_desktop_entry(<command>, [name], [icon], [type], [fields])
750# 551#
751# binary: what command does the app run with ? 552# binary: what command does the app run with ?
752# name: the name that will show up in the menu 553# name: the name that will show up in the menu
753# icon: give your little like a pretty little icon ... 554# icon: give your little like a pretty little icon ...
754# this can be relative (to /usr/share/pixmaps) or 555# this can be relative (to /usr/share/pixmaps) or
755# a full path to an icon 556# a full path to an icon
756# type: what kind of application is this ? for categories: 557# type: what kind of application is this ? for categories:
757# http://standards.freedesktop.org/menu-spec/latest/apa.html 558# http://standards.freedesktop.org/menu-spec/latest/apa.html
758# path: if your app needs to startup in a specific dir 559# fields: extra fields to append to the desktop file; a printf string
759make_desktop_entry() { 560make_desktop_entry() {
760 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 561 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
761 562
762 local exec=${1} 563 local exec=${1}
763 local name=${2:-${PN}} 564 local name=${2:-${PN}}
764 local icon=${3:-${PN}} 565 local icon=${3:-${PN}}
765 local type=${4} 566 local type=${4}
766 local path=${5} 567 local fields=${5}
767 568
768 if [[ -z ${type} ]] ; then 569 if [[ -z ${type} ]] ; then
769 local catmaj=${CATEGORY%%-*} 570 local catmaj=${CATEGORY%%-*}
770 local catmin=${CATEGORY##*-} 571 local catmin=${CATEGORY##*-}
771 case ${catmaj} in 572 case ${catmaj} in
772 app) 573 app)
773 case ${catmin} in 574 case ${catmin} in
774 accessibility) type=Accessibility;; 575 accessibility) type=Accessibility;;
775 admin) type=System;; 576 admin) type=System;;
776 antivirus) type=System;; 577 antivirus) type=System;;
777 arch) type=Archiving;; 578 arch) type=Archiving;;
778 backup) type=Archiving;; 579 backup) type=Archiving;;
779 cdr) type=DiscBurning;; 580 cdr) type=DiscBurning;;
780 dicts) type=Dictionary;; 581 dicts) type=Dictionary;;
781 doc) type=Documentation;; 582 doc) type=Documentation;;
782 editors) type=TextEditor;; 583 editors) type=TextEditor;;
783 emacs) type=TextEditor;; 584 emacs) type=TextEditor;;
784 emulation) type=Emulator;; 585 emulation) type=Emulator;;
785 laptop) type=HardwareSettings;; 586 laptop) type=HardwareSettings;;
786 office) type=Office;; 587 office) type=Office;;
787 pda) type=PDA;; 588 pda) type=PDA;;
788 vim) type=TextEditor;; 589 vim) type=TextEditor;;
789 xemacs) type=TextEditor;; 590 xemacs) type=TextEditor;;
790 *) type=;;
791 esac 591 esac
792 ;; 592 ;;
793 593
794 dev) 594 dev)
795 type="Development" 595 type="Development"
796 ;; 596 ;;
797 597
798 games) 598 games)
799 case ${catmin} in 599 case ${catmin} in
800 action|fps) type=ActionGame;; 600 action|fps) type=ActionGame;;
801 arcade) type=ArcadeGame;; 601 arcade) type=ArcadeGame;;
802 board) type=BoardGame;; 602 board) type=BoardGame;;
803 emulation) type=Emulator;; 603 emulation) type=Emulator;;
804 kids) type=KidsGame;; 604 kids) type=KidsGame;;
805 puzzle) type=LogicGame;; 605 puzzle) type=LogicGame;;
806 roguelike) type=RolePlaying;; 606 roguelike) type=RolePlaying;;
807 rpg) type=RolePlaying;; 607 rpg) type=RolePlaying;;
808 simulation) type=Simulation;; 608 simulation) type=Simulation;;
809 sports) type=SportsGame;; 609 sports) type=SportsGame;;
810 strategy) type=StrategyGame;; 610 strategy) type=StrategyGame;;
811 *) type=;;
812 esac 611 esac
813 type="Game;${type}" 612 type="Game;${type}"
814 ;; 613 ;;
815 614
816 gnome) 615 gnome)
825 type="Network;Email" 624 type="Network;Email"
826 ;; 625 ;;
827 626
828 media) 627 media)
829 case ${catmin} in 628 case ${catmin} in
629 gfx)
830 gfx) type=Graphics;; 630 type=Graphics
631 ;;
632 *)
633 case ${catmin} in
831 radio) type=Tuner;; 634 radio) type=Tuner;;
832 sound) type=Audio;; 635 sound) type=Audio;;
833 tv) type=TV;; 636 tv) type=TV;;
834 video) type=Video;; 637 video) type=Video;;
835 *) type=;; 638 esac
639 type="AudioVideo;${type}"
640 ;;
836 esac 641 esac
837 type="AudioVideo;${type}"
838 ;; 642 ;;
839 643
840 net) 644 net)
841 case ${catmin} in 645 case ${catmin} in
842 dialup) type=Dialup;; 646 dialup) type=Dialup;;
843 ftp) type=FileTransfer;; 647 ftp) type=FileTransfer;;
844 im) type=InstantMessaging;; 648 im) type=InstantMessaging;;
845 irc) type=IRCClient;; 649 irc) type=IRCClient;;
846 mail) type=Email;; 650 mail) type=Email;;
847 news) type=News;; 651 news) type=News;;
848 nntp) type=News;; 652 nntp) type=News;;
849 p2p) type=FileTransfer;; 653 p2p) type=FileTransfer;;
850 *) type=;; 654 voip) type=Telephony;;
851 esac 655 esac
852 type="Network;${type}" 656 type="Network;${type}"
853 ;; 657 ;;
854 658
855 sci) 659 sci)
856 case ${catmin} in 660 case ${catmin} in
857 astro*) type=Astronomy;; 661 astro*) type=Astronomy;;
858 bio*) type=Biology;; 662 bio*) type=Biology;;
859 calc*) type=Calculator;; 663 calc*) type=Calculator;;
860 chem*) type=Chemistry;; 664 chem*) type=Chemistry;;
861 elec*) type=Electronics;; 665 elec*) type=Electronics;;
862 geo*) type=Geology;; 666 geo*) type=Geology;;
863 math*) type=Math;; 667 math*) type=Math;;
864 physics) type=Physics;; 668 physics) type=Physics;;
865 visual*) type=DataVisualization;; 669 visual*) type=DataVisualization;;
866 *) type=;;
867 esac 670 esac
868 type="Science;${type}" 671 type="Education;Science;${type}"
869 ;; 672 ;;
870 673
871 sys) 674 sys)
872 type="System" 675 type="System"
873 ;; 676 ;;
874 677
875 www) 678 www)
876 case ${catmin} in 679 case ${catmin} in
877 client) type=WebBrowser;; 680 client) type=WebBrowser;;
878 *) type=;;
879 esac 681 esac
880 type="Network" 682 type="Network;${type}"
881 ;; 683 ;;
882 684
883 *) 685 *)
884 type= 686 type=
885 ;; 687 ;;
891 local desktop_name="${PN}-${SLOT}" 693 local desktop_name="${PN}-${SLOT}"
892 fi 694 fi
893 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 695 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 696 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 697
698 # Don't append another ";" when a valid category value is provided.
699 type=${type%;}${type:+;}
700
701 eshopts_push -s extglob
702 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
703 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
704 ewarn "allowed in .desktop files if the value is not an absolute path."
705 icon=${icon%.@(xpm|png|svg)}
706 fi
707 eshopts_pop
708
896 cat <<-EOF > "${desktop}" 709 cat <<-EOF > "${desktop}"
897 [Desktop Entry] 710 [Desktop Entry]
898 Version=1.0
899 Name=${name} 711 Name=${name}
900 Type=Application 712 Type=Application
901 Comment=${DESCRIPTION} 713 Comment=${DESCRIPTION}
902 Exec=${exec} 714 Exec=${exec}
903 TryExec=${exec%% *} 715 TryExec=${exec%% *}
904 Icon=${icon} 716 Icon=${icon}
905 Categories=${type}; 717 Categories=${type}
906 EOF 718 EOF
907 719
908 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 720 if [[ ${fields:-=} != *=* ]] ; then
721 # 5th arg used to be value to Path=
722 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
723 fields="Path=${fields}"
724 fi
725 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
909 726
910 ( 727 (
911 # wrap the env here so that the 'insinto' call 728 # wrap the env here so that the 'insinto' call
912 # doesn't corrupt the env of the caller 729 # doesn't corrupt the env of the caller
913 insinto /usr/share/applications 730 insinto /usr/share/applications
914 doins "${desktop}" 731 doins "${desktop}"
915 ) 732 ) || die "installing desktop file failed"
916} 733}
917 734
918# @FUNCTION: validate_desktop_entries 735# @FUNCTION: validate_desktop_entries
919# @USAGE: [directories] 736# @USAGE: [directories]
920# @MAINTAINER: 737# @MAINTAINER:
942 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 759 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
943 fi 760 fi
944} 761}
945 762
946# @FUNCTION: make_session_desktop 763# @FUNCTION: make_session_desktop
947# @USAGE: <title> <command> 764# @USAGE: <title> <command> [command args...]
948# @DESCRIPTION: 765# @DESCRIPTION:
949# Make a GDM/KDM Session file. The title is the file to execute to start the 766# Make a GDM/KDM Session file. The title is the file to execute to start the
950# Window Manager. The command is the name of the Window Manager. 767# Window Manager. The command is the name of the Window Manager.
768#
769# You can set the name of the file via the ${wm} variable.
951make_session_desktop() { 770make_session_desktop() {
952 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 771 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
953 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 772 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
954 773
955 local title=$1 774 local title=$1
956 local command=$2 775 local command=$2
957 local desktop=${T}/${wm}.desktop 776 local desktop=${T}/${wm:-${PN}}.desktop
777 shift 2
958 778
959 cat <<-EOF > "${desktop}" 779 cat <<-EOF > "${desktop}"
960 [Desktop Entry] 780 [Desktop Entry]
961 Name=${title} 781 Name=${title}
962 Comment=This session logs you into ${title} 782 Comment=This session logs you into ${title}
963 Exec=${command} 783 Exec=${command} $*
964 TryExec=${command} 784 TryExec=${command}
965 Type=Application 785 Type=XSession
966 EOF 786 EOF
967 787
968 ( 788 (
969 # wrap the env here so that the 'insinto' call 789 # wrap the env here so that the 'insinto' call
970 # doesn't corrupt the env of the caller 790 # doesn't corrupt the env of the caller
1196 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1016 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1197 1017
1198 local shrtsrc=$(basename "${src}") 1018 local shrtsrc=$(basename "${src}")
1199 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1019 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1200 if [[ -z ${skip} ]] ; then 1020 if [[ -z ${skip} ]] ; then
1201 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1021 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1202 local skip=0 1022 local skip=0
1203 exe=tail 1023 exe=tail
1204 case ${ver} in 1024 case ${ver} in
1205 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1025 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1206 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1026 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1208 2.0|2.0.1) 1028 2.0|2.0.1)
1209 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1029 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1210 ;; 1030 ;;
1211 2.1.1) 1031 2.1.1)
1212 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1032 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1213 let skip="skip + 1" 1033 (( skip++ ))
1214 ;; 1034 ;;
1215 2.1.2) 1035 2.1.2)
1216 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1036 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1217 let skip="skip + 1" 1037 (( skip++ ))
1218 ;; 1038 ;;
1219 2.1.3) 1039 2.1.3)
1220 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1040 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1221 let skip="skip + 1" 1041 (( skip++ ))
1222 ;; 1042 ;;
1223 2.1.4|2.1.5) 1043 2.1.4|2.1.5)
1224 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1044 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1225 skip=$(head -n ${skip} "${src}" | wc -c) 1045 skip=$(head -n ${skip} "${src}" | wc -c)
1226 exe="dd" 1046 exe="dd"
1235 esac 1055 esac
1236 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1056 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1237 fi 1057 fi
1238 case ${exe} in 1058 case ${exe} in
1239 tail) exe="tail -n +${skip} '${src}'";; 1059 tail) exe="tail -n +${skip} '${src}'";;
1240 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1060 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1241 *) die "makeself cant handle exe '${exe}'" 1061 *) die "makeself cant handle exe '${exe}'"
1242 esac 1062 esac
1243 1063
1244 # lets grab the first few bytes of the file to figure out what kind of archive it is 1064 # lets grab the first few bytes of the file to figure out what kind of archive it is
1245 local tmpfile=$(emktemp) 1065 local filetype tmpfile=$(emktemp)
1246 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1066 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1247 local filetype=$(file -b "${tmpfile}") 1067 filetype=$(file -b "${tmpfile}") || die
1248 case ${filetype} in 1068 case ${filetype} in
1249 *tar\ archive*) 1069 *tar\ archive*)
1250 eval ${exe} | tar --no-same-owner -xf - 1070 eval ${exe} | tar --no-same-owner -xf -
1251 ;; 1071 ;;
1252 bzip2*) 1072 bzip2*)
1282 lic="${PWD}/${lic}" 1102 lic="${PWD}/${lic}"
1283 elif [ -e "${lic}" ] ; then 1103 elif [ -e "${lic}" ] ; then
1284 lic="${lic}" 1104 lic="${lic}"
1285 fi 1105 fi
1286 fi 1106 fi
1287 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1288 local l="`basename ${lic}`" 1107 local l="`basename ${lic}`"
1289 1108
1290 # here is where we check for the licenses the user already 1109 # here is where we check for the licenses the user already
1291 # accepted ... if we don't find a match, we make the user accept 1110 # accepted ... if we don't find a match, we make the user accept
1292 local shopts=$-
1293 local alic 1111 local alic
1294 set -o noglob #so that bash doesn't expand "*" 1112 eshopts_push -o noglob # so that bash doesn't expand "*"
1295 for alic in ${ACCEPT_LICENSE} ; do 1113 for alic in ${ACCEPT_LICENSE} ; do
1296 if [[ ${alic} == ${l} ]]; then 1114 if [[ ${alic} == ${l} ]]; then
1297 set +o noglob; set -${shopts} #reset old shell opts 1115 eshopts_pop
1298 return 0 1116 return 0
1299 fi 1117 fi
1300 done 1118 done
1301 set +o noglob; set -$shopts #reset old shell opts 1119 eshopts_pop
1120 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1302 1121
1303 local licmsg=$(emktemp) 1122 local licmsg=$(emktemp)
1304 cat <<-EOF > ${licmsg} 1123 cat <<-EOF > ${licmsg}
1305 ********************************************************** 1124 **********************************************************
1306 The following license outlines the terms of use of this 1125 The following license outlines the terms of use of this
1379 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1198 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1380 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1199 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1381 export CDROM_SET=-1 1200 export CDROM_SET=-1
1382 for f in ${CDROM_CHECK_1//:/ } ; do 1201 for f in ${CDROM_CHECK_1//:/ } ; do
1383 ((++CDROM_SET)) 1202 ((++CDROM_SET))
1384 [[ -e ${CD_ROOT}/${f} ]] && break 1203 [[ -e ${CDROM_ROOT}/${f} ]] && break
1385 done 1204 done
1386 export CDROM_MATCH=${f} 1205 export CDROM_MATCH=${f}
1387 return 1206 return
1388 fi 1207 fi
1389 1208
1553# of the lists. 1372# of the lists.
1554strip-linguas() { 1373strip-linguas() {
1555 local ls newls nols 1374 local ls newls nols
1556 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1375 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1557 local op=$1; shift 1376 local op=$1; shift
1558 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1377 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1559 local d f 1378 local d f
1560 for d in "$@" ; do 1379 for d in "$@" ; do
1561 if [[ ${op} == "-u" ]] ; then 1380 if [[ ${op} == "-u" ]] ; then
1562 newls=${ls} 1381 newls=${ls}
1563 else 1382 else
1564 newls="" 1383 newls=""
1565 fi 1384 fi
1566 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1385 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1567 if [[ ${op} == "-i" ]] ; then 1386 if [[ ${op} == "-i" ]] ; then
1568 hasq ${f} ${ls} && newls="${newls} ${f}" 1387 has ${f} ${ls} && newls="${newls} ${f}"
1569 else 1388 else
1570 hasq ${f} ${ls} || newls="${newls} ${f}" 1389 has ${f} ${ls} || newls="${newls} ${f}"
1571 fi 1390 fi
1572 done 1391 done
1573 ls=${newls} 1392 ls=${newls}
1574 done 1393 done
1575 else 1394 else
1577 fi 1396 fi
1578 1397
1579 nols="" 1398 nols=""
1580 newls="" 1399 newls=""
1581 for f in ${LINGUAS} ; do 1400 for f in ${LINGUAS} ; do
1582 if hasq ${f} ${ls} ; then 1401 if has ${f} ${ls} ; then
1583 newls="${newls} ${f}" 1402 newls="${newls} ${f}"
1584 else 1403 else
1585 nols="${nols} ${f}" 1404 nols="${nols} ${f}"
1586 fi 1405 fi
1587 done 1406 done
1588 [[ -n ${nols} ]] \ 1407 [[ -n ${nols} ]] \
1589 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1408 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1590 export LINGUAS=${newls:1} 1409 export LINGUAS=${newls:1}
1591} 1410}
1592 1411
1593# @FUNCTION: preserve_old_lib 1412# @FUNCTION: preserve_old_lib
1594# @USAGE: <libs to preserve> [more libs] 1413# @USAGE: <libs to preserve> [more libs]
1642 ewarn "the libraries are not being removed. You need to run revdep-rebuild" 1461 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1643 ewarn "in order to remove these old dependencies. If you do not have this" 1462 ewarn "in order to remove these old dependencies. If you do not have this"
1644 ewarn "helper program, simply emerge the 'gentoolkit' package." 1463 ewarn "helper program, simply emerge the 'gentoolkit' package."
1645 ewarn 1464 ewarn
1646 fi 1465 fi
1466 # temp hack for #348634 #357225
1467 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1647 ewarn " # revdep-rebuild --library ${lib##*/}" 1468 ewarn " # revdep-rebuild --library '${lib}'"
1648 done 1469 done
1649 if [[ ${notice} -eq 1 ]] ; then 1470 if [[ ${notice} -eq 1 ]] ; then
1650 ewarn 1471 ewarn
1651 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1472 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1652 ewarn "delete the old libraries. Here is a copy & paste for the lazy:" 1473 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1657} 1478}
1658 1479
1659# @FUNCTION: built_with_use 1480# @FUNCTION: built_with_use
1660# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1481# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1661# @DESCRIPTION: 1482# @DESCRIPTION:
1483#
1484# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1485#
1662# A temporary hack until portage properly supports DEPENDing on USE 1486# A temporary hack until portage properly supports DEPENDing on USE
1663# flags being enabled in packages. This will check to see if the specified 1487# flags being enabled in packages. This will check to see if the specified
1664# DEPEND atom was built with the specified list of USE flags. The 1488# DEPEND atom was built with the specified list of USE flags. The
1665# --missing option controls the behavior if called on a package that does 1489# --missing option controls the behavior if called on a package that does
1666# not actually support the defined USE flags (aka listed in IUSE). 1490# not actually support the defined USE flags (aka listed in IUSE).
1794 ) || die 1618 ) || die
1795 else 1619 else
1796 newbin "${tmpwrapper}" "${wrapper}" || die 1620 newbin "${tmpwrapper}" "${wrapper}" || die
1797 fi 1621 fi
1798} 1622}
1623
1624# @FUNCTION: path_exists
1625# @USAGE: [-a|-o] <paths>
1626# @DESCRIPTION:
1627# Check if the specified paths exist. Works for all types of paths
1628# (files/dirs/etc...). The -a and -o flags control the requirements
1629# of the paths. They correspond to "and" and "or" logic. So the -a
1630# flag means all the paths must exist while the -o flag means at least
1631# one of the paths must exist. The default behavior is "and". If no
1632# paths are specified, then the return value is "false".
1633path_exists() {
1634 local opt=$1
1635 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1636
1637 # no paths -> return false
1638 # same behavior as: [[ -e "" ]]
1639 [[ $# -eq 0 ]] && return 1
1640
1641 local p r=0
1642 for p in "$@" ; do
1643 [[ -e ${p} ]]
1644 : $(( r += $? ))
1645 done
1646
1647 case ${opt} in
1648 -a) return $(( r != 0 )) ;;
1649 -o) return $(( r == $# )) ;;
1650 esac
1651}
1652
1653# @FUNCTION: in_iuse
1654# @USAGE: <flag>
1655# @DESCRIPTION:
1656# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1657# as necessary.
1658#
1659# Note that this function should not be used in the global scope.
1660in_iuse() {
1661 debug-print-function ${FUNCNAME} "${@}"
1662 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1663
1664 local flag=${1}
1665 local liuse=( ${IUSE} )
1666
1667 has "${flag}" "${liuse[@]#[+-]}"
1668}
1669
1670# @FUNCTION: use_if_iuse
1671# @USAGE: <flag>
1672# @DESCRIPTION:
1673# Return true if the given flag is in USE and IUSE.
1674#
1675# Note that this function should not be used in the global scope.
1676use_if_iuse() {
1677 in_iuse $1 || return 1
1678 use $1
1679}
1680
1681# @FUNCTION: usex
1682# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1683# @DESCRIPTION:
1684# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1685# otherwise echo [false output][false suffix] (defaults to "no").
1686usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.304  
changed lines
  Added in v.1.369

  ViewVC Help
Powered by ViewVC 1.1.20